From 1a1b1de505630df4d14f42d09d08e96ff7c7ae70 Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Thu, 16 Jun 2016 15:35:20 -0500
Subject: [PATCH] Removed unused Tomcat 6 files.

https://fedorahosted.org/pki/ticket/2363
---
 base/ca/shared/conf/tomcat6.conf   | 58 --------------------------------------
 base/kra/shared/conf/tomcat6.conf  | 58 --------------------------------------
 base/ocsp/shared/conf/tomcat6.conf | 58 --------------------------------------
 base/tks/shared/conf/tomcat6.conf  | 58 --------------------------------------
 base/tps/shared/conf/tomcat6.conf  | 58 --------------------------------------
 5 files changed, 290 deletions(-)
 delete mode 100644 base/ca/shared/conf/tomcat6.conf
 delete mode 100644 base/kra/shared/conf/tomcat6.conf
 delete mode 100644 base/ocsp/shared/conf/tomcat6.conf
 delete mode 100644 base/tks/shared/conf/tomcat6.conf
 delete mode 100644 base/tps/shared/conf/tomcat6.conf

diff --git a/base/ca/shared/conf/tomcat6.conf b/base/ca/shared/conf/tomcat6.conf
deleted file mode 100644
index 2d7def5ec9256dc59d89c3197c5e723c113a3779..0000000000000000000000000000000000000000
--- a/base/ca/shared/conf/tomcat6.conf
+++ /dev/null
@@ -1,58 +0,0 @@
-# Service-specific configuration file for tomcat6. This will be sourced by
-# the SysV init script after the global configuration file
-# /etc/tomcat6/tomcat6.conf, thus allowing values to be overridden in
-# a per-service manner.
-#
-# NEVER change the init script itself. To change values for all services make
-# your changes in /etc/tomcat6/tomcat6.conf
-#
-# To change values for a specific service make your edits here.
-# To create a new service create a link from /etc/init.d/<your new service> to
-# /etc/init.d/tomcat6 (do not copy the init script) and make a copy of the
-# /etc/sysconfig/tomcat6 file to /etc/sysconfig/<your new service> and change
-# the property values so the two services won't conflict. Register the new
-# service in the system as usual (see chkconfig and similars).
-#
-
-# Where your java installation lives
-#JAVA_HOME="/usr/lib/jvm/java"
-
-# Where your tomcat installation lives
-CATALINA_BASE="[PKI_INSTANCE_PATH]"
-#CATALINA_HOME="/usr/share/tomcat6"
-#JASPER_HOME="/usr/share/tomcat6"
-#CATALINA_TMPDIR="/var/cache/tomcat6/temp"
-
-# You can pass some parameters to java here if you wish to
-#JAVA_OPTS="-Xminf0.1 -Xmaxf0.3"
-
-# Use JAVA_OPTS to set java.library.path for libtcnative.so
-#JAVA_OPTS="-Djava.library.path=/usr/lib64"
-
-# What user should run tomcat
-TOMCAT_USER="[PKI_USER]"
-
-# You can change your tomcat locale here
-#LANG="en_US"
-
-# Run tomcat under the Java Security Manager
-#SECURITY_MANAGER="false"
-
-# Time to wait in seconds, before killing process
-#SHUTDOWN_WAIT="30"
-
-# Whether to annoy the user with "attempting to shut down" messages or not
-#SHUTDOWN_VERBOSE="false"
-
-# Set the TOMCAT_PID location
-CATALINA_PID="[TOMCAT_PIDFILE]"
-
-# Set the tomcat log file
-TOMCAT_LOG="[TOMCAT_LOG_DIR]/tomcat-initd.log"
-
-# Connector port is 8080 for this tomcat6 instance
-#CONNECTOR_PORT="8080"
-
-# If you wish to further customize your tomcat environment,
-# put your own definitions here
-# (i.e. LD_LIBRARY_PATH for some jdbc drivers)
diff --git a/base/kra/shared/conf/tomcat6.conf b/base/kra/shared/conf/tomcat6.conf
deleted file mode 100644
index 2d7def5ec9256dc59d89c3197c5e723c113a3779..0000000000000000000000000000000000000000
--- a/base/kra/shared/conf/tomcat6.conf
+++ /dev/null
@@ -1,58 +0,0 @@
-# Service-specific configuration file for tomcat6. This will be sourced by
-# the SysV init script after the global configuration file
-# /etc/tomcat6/tomcat6.conf, thus allowing values to be overridden in
-# a per-service manner.
-#
-# NEVER change the init script itself. To change values for all services make
-# your changes in /etc/tomcat6/tomcat6.conf
-#
-# To change values for a specific service make your edits here.
-# To create a new service create a link from /etc/init.d/<your new service> to
-# /etc/init.d/tomcat6 (do not copy the init script) and make a copy of the
-# /etc/sysconfig/tomcat6 file to /etc/sysconfig/<your new service> and change
-# the property values so the two services won't conflict. Register the new
-# service in the system as usual (see chkconfig and similars).
-#
-
-# Where your java installation lives
-#JAVA_HOME="/usr/lib/jvm/java"
-
-# Where your tomcat installation lives
-CATALINA_BASE="[PKI_INSTANCE_PATH]"
-#CATALINA_HOME="/usr/share/tomcat6"
-#JASPER_HOME="/usr/share/tomcat6"
-#CATALINA_TMPDIR="/var/cache/tomcat6/temp"
-
-# You can pass some parameters to java here if you wish to
-#JAVA_OPTS="-Xminf0.1 -Xmaxf0.3"
-
-# Use JAVA_OPTS to set java.library.path for libtcnative.so
-#JAVA_OPTS="-Djava.library.path=/usr/lib64"
-
-# What user should run tomcat
-TOMCAT_USER="[PKI_USER]"
-
-# You can change your tomcat locale here
-#LANG="en_US"
-
-# Run tomcat under the Java Security Manager
-#SECURITY_MANAGER="false"
-
-# Time to wait in seconds, before killing process
-#SHUTDOWN_WAIT="30"
-
-# Whether to annoy the user with "attempting to shut down" messages or not
-#SHUTDOWN_VERBOSE="false"
-
-# Set the TOMCAT_PID location
-CATALINA_PID="[TOMCAT_PIDFILE]"
-
-# Set the tomcat log file
-TOMCAT_LOG="[TOMCAT_LOG_DIR]/tomcat-initd.log"
-
-# Connector port is 8080 for this tomcat6 instance
-#CONNECTOR_PORT="8080"
-
-# If you wish to further customize your tomcat environment,
-# put your own definitions here
-# (i.e. LD_LIBRARY_PATH for some jdbc drivers)
diff --git a/base/ocsp/shared/conf/tomcat6.conf b/base/ocsp/shared/conf/tomcat6.conf
deleted file mode 100644
index 2d7def5ec9256dc59d89c3197c5e723c113a3779..0000000000000000000000000000000000000000
--- a/base/ocsp/shared/conf/tomcat6.conf
+++ /dev/null
@@ -1,58 +0,0 @@
-# Service-specific configuration file for tomcat6. This will be sourced by
-# the SysV init script after the global configuration file
-# /etc/tomcat6/tomcat6.conf, thus allowing values to be overridden in
-# a per-service manner.
-#
-# NEVER change the init script itself. To change values for all services make
-# your changes in /etc/tomcat6/tomcat6.conf
-#
-# To change values for a specific service make your edits here.
-# To create a new service create a link from /etc/init.d/<your new service> to
-# /etc/init.d/tomcat6 (do not copy the init script) and make a copy of the
-# /etc/sysconfig/tomcat6 file to /etc/sysconfig/<your new service> and change
-# the property values so the two services won't conflict. Register the new
-# service in the system as usual (see chkconfig and similars).
-#
-
-# Where your java installation lives
-#JAVA_HOME="/usr/lib/jvm/java"
-
-# Where your tomcat installation lives
-CATALINA_BASE="[PKI_INSTANCE_PATH]"
-#CATALINA_HOME="/usr/share/tomcat6"
-#JASPER_HOME="/usr/share/tomcat6"
-#CATALINA_TMPDIR="/var/cache/tomcat6/temp"
-
-# You can pass some parameters to java here if you wish to
-#JAVA_OPTS="-Xminf0.1 -Xmaxf0.3"
-
-# Use JAVA_OPTS to set java.library.path for libtcnative.so
-#JAVA_OPTS="-Djava.library.path=/usr/lib64"
-
-# What user should run tomcat
-TOMCAT_USER="[PKI_USER]"
-
-# You can change your tomcat locale here
-#LANG="en_US"
-
-# Run tomcat under the Java Security Manager
-#SECURITY_MANAGER="false"
-
-# Time to wait in seconds, before killing process
-#SHUTDOWN_WAIT="30"
-
-# Whether to annoy the user with "attempting to shut down" messages or not
-#SHUTDOWN_VERBOSE="false"
-
-# Set the TOMCAT_PID location
-CATALINA_PID="[TOMCAT_PIDFILE]"
-
-# Set the tomcat log file
-TOMCAT_LOG="[TOMCAT_LOG_DIR]/tomcat-initd.log"
-
-# Connector port is 8080 for this tomcat6 instance
-#CONNECTOR_PORT="8080"
-
-# If you wish to further customize your tomcat environment,
-# put your own definitions here
-# (i.e. LD_LIBRARY_PATH for some jdbc drivers)
diff --git a/base/tks/shared/conf/tomcat6.conf b/base/tks/shared/conf/tomcat6.conf
deleted file mode 100644
index 2d7def5ec9256dc59d89c3197c5e723c113a3779..0000000000000000000000000000000000000000
--- a/base/tks/shared/conf/tomcat6.conf
+++ /dev/null
@@ -1,58 +0,0 @@
-# Service-specific configuration file for tomcat6. This will be sourced by
-# the SysV init script after the global configuration file
-# /etc/tomcat6/tomcat6.conf, thus allowing values to be overridden in
-# a per-service manner.
-#
-# NEVER change the init script itself. To change values for all services make
-# your changes in /etc/tomcat6/tomcat6.conf
-#
-# To change values for a specific service make your edits here.
-# To create a new service create a link from /etc/init.d/<your new service> to
-# /etc/init.d/tomcat6 (do not copy the init script) and make a copy of the
-# /etc/sysconfig/tomcat6 file to /etc/sysconfig/<your new service> and change
-# the property values so the two services won't conflict. Register the new
-# service in the system as usual (see chkconfig and similars).
-#
-
-# Where your java installation lives
-#JAVA_HOME="/usr/lib/jvm/java"
-
-# Where your tomcat installation lives
-CATALINA_BASE="[PKI_INSTANCE_PATH]"
-#CATALINA_HOME="/usr/share/tomcat6"
-#JASPER_HOME="/usr/share/tomcat6"
-#CATALINA_TMPDIR="/var/cache/tomcat6/temp"
-
-# You can pass some parameters to java here if you wish to
-#JAVA_OPTS="-Xminf0.1 -Xmaxf0.3"
-
-# Use JAVA_OPTS to set java.library.path for libtcnative.so
-#JAVA_OPTS="-Djava.library.path=/usr/lib64"
-
-# What user should run tomcat
-TOMCAT_USER="[PKI_USER]"
-
-# You can change your tomcat locale here
-#LANG="en_US"
-
-# Run tomcat under the Java Security Manager
-#SECURITY_MANAGER="false"
-
-# Time to wait in seconds, before killing process
-#SHUTDOWN_WAIT="30"
-
-# Whether to annoy the user with "attempting to shut down" messages or not
-#SHUTDOWN_VERBOSE="false"
-
-# Set the TOMCAT_PID location
-CATALINA_PID="[TOMCAT_PIDFILE]"
-
-# Set the tomcat log file
-TOMCAT_LOG="[TOMCAT_LOG_DIR]/tomcat-initd.log"
-
-# Connector port is 8080 for this tomcat6 instance
-#CONNECTOR_PORT="8080"
-
-# If you wish to further customize your tomcat environment,
-# put your own definitions here
-# (i.e. LD_LIBRARY_PATH for some jdbc drivers)
diff --git a/base/tps/shared/conf/tomcat6.conf b/base/tps/shared/conf/tomcat6.conf
deleted file mode 100644
index 2d7def5ec9256dc59d89c3197c5e723c113a3779..0000000000000000000000000000000000000000
--- a/base/tps/shared/conf/tomcat6.conf
+++ /dev/null
@@ -1,58 +0,0 @@
-# Service-specific configuration file for tomcat6. This will be sourced by
-# the SysV init script after the global configuration file
-# /etc/tomcat6/tomcat6.conf, thus allowing values to be overridden in
-# a per-service manner.
-#
-# NEVER change the init script itself. To change values for all services make
-# your changes in /etc/tomcat6/tomcat6.conf
-#
-# To change values for a specific service make your edits here.
-# To create a new service create a link from /etc/init.d/<your new service> to
-# /etc/init.d/tomcat6 (do not copy the init script) and make a copy of the
-# /etc/sysconfig/tomcat6 file to /etc/sysconfig/<your new service> and change
-# the property values so the two services won't conflict. Register the new
-# service in the system as usual (see chkconfig and similars).
-#
-
-# Where your java installation lives
-#JAVA_HOME="/usr/lib/jvm/java"
-
-# Where your tomcat installation lives
-CATALINA_BASE="[PKI_INSTANCE_PATH]"
-#CATALINA_HOME="/usr/share/tomcat6"
-#JASPER_HOME="/usr/share/tomcat6"
-#CATALINA_TMPDIR="/var/cache/tomcat6/temp"
-
-# You can pass some parameters to java here if you wish to
-#JAVA_OPTS="-Xminf0.1 -Xmaxf0.3"
-
-# Use JAVA_OPTS to set java.library.path for libtcnative.so
-#JAVA_OPTS="-Djava.library.path=/usr/lib64"
-
-# What user should run tomcat
-TOMCAT_USER="[PKI_USER]"
-
-# You can change your tomcat locale here
-#LANG="en_US"
-
-# Run tomcat under the Java Security Manager
-#SECURITY_MANAGER="false"
-
-# Time to wait in seconds, before killing process
-#SHUTDOWN_WAIT="30"
-
-# Whether to annoy the user with "attempting to shut down" messages or not
-#SHUTDOWN_VERBOSE="false"
-
-# Set the TOMCAT_PID location
-CATALINA_PID="[TOMCAT_PIDFILE]"
-
-# Set the tomcat log file
-TOMCAT_LOG="[TOMCAT_LOG_DIR]/tomcat-initd.log"
-
-# Connector port is 8080 for this tomcat6 instance
-#CONNECTOR_PORT="8080"
-
-# If you wish to further customize your tomcat environment,
-# put your own definitions here
-# (i.e. LD_LIBRARY_PATH for some jdbc drivers)
-- 
2.4.11